git-submodule.sh: align error reporting for update mode to use path
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
a0ef2934 45dissociate=
70c7ac22 46
be9d0a3a
HV
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
c4c02bf1 51 exit ${2:-1}
be9d0a3a
HV
52 fi
53}
54
88ce00c3
TK
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78}
79
862ae6cd
RS
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
14111fc4
JK
85# Sanitize the local git environment for use within a submodule. We
86# can't simply use clear_local_git_env since we want to preserve some
87# of the settings from GIT_CONFIG_PARAMETERS.
88sanitize_submodule_env()
89{
89044baa 90 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 91 clear_local_git_env
89044baa 92 GIT_CONFIG_PARAMETERS=$save_config
860cba61 93 export GIT_CONFIG_PARAMETERS
14111fc4
JK
94}
95
ecda0723
SV
96#
97# Add a new submodule to the working tree, .gitmodules and the index
98#
ec05df35 99# $@ = repo path
ecda0723
SV
100#
101# optional branch is stored in global branch variable
102#
23a485e3 103cmd_add()
ecda0723 104{
5c08dbbd 105 # parse $args after "submodule ... add".
091a6eb0 106 reference_path=
5c08dbbd
JH
107 while test $# -ne 0
108 do
109 case "$1" in
110 -b | --branch)
111 case "$2" in '') usage ;; esac
112 branch=$2
113 shift
114 ;;
d27b876b
JL
115 -f | --force)
116 force=$1
117 ;;
5c08dbbd 118 -q|--quiet)
2e6a30ef 119 GIT_QUIET=1
5c08dbbd 120 ;;
6d33e1c2
CF
121 --progress)
122 progress=1
123 ;;
d92a3959
MT
124 --reference)
125 case "$2" in '') usage ;; esac
091a6eb0 126 reference_path=$2
d92a3959
MT
127 shift
128 ;;
129 --reference=*)
091a6eb0 130 reference_path="${1#--reference=}"
d92a3959 131 ;;
a0ef2934
CF
132 --dissociate)
133 dissociate=1
134 ;;
73b0898d
JL
135 --name)
136 case "$2" in '') usage ;; esac
137 custom_name=$2
138 shift
139 ;;
275cd184
FG
140 --depth)
141 case "$2" in '') usage ;; esac
142 depth="--depth=$2"
143 shift
144 ;;
145 --depth=*)
146 depth=$1
147 ;;
5c08dbbd
JH
148 --)
149 shift
150 break
151 ;;
152 -*)
153 usage
154 ;;
155 *)
156 break
157 ;;
158 esac
159 shift
160 done
161
091a6eb0
JK
162 if test -n "$reference_path"
163 then
164 is_absolute_path "$reference_path" ||
165 reference_path="$wt_prefix$reference_path"
166
167 reference="--reference=$reference_path"
168 fi
169
ecda0723 170 repo=$1
64394e3a 171 sm_path=$2
ecda0723 172
64394e3a 173 if test -z "$sm_path"; then
6a066230 174 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
175 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
176 fi
177
496eeeb1 178 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
179 usage
180 fi
181
091a6eb0
JK
182 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
183
ec05df35
ML
184 # assure repo is absolute or relative to parent
185 case "$repo" in
186 ./*|../*)
091a6eb0
JK
187 test -z "$wt_prefix" ||
188 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
189
ec05df35 190 # dereference source url relative to parent's url
63e95beb 191 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
192 ;;
193 *:*|/*)
194 # absolute url
195 realrepo=$repo
196 ;;
197 *)
497ee872 198 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
199 ;;
200 esac
201
db75ada5
MG
202 # normalize path:
203 # multiple //; leading ./; /./; /../; trailing /
64394e3a 204 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
205 sed -e '
206 s|//*|/|g
207 s|^\(\./\)*||
8196e728 208 s|/\(\./\)*|/|g
db75ada5
MG
209 :start
210 s|\([^/]*\)/\.\./||
211 tstart
212 s|/*$||
213 ')
619acfc7
SB
214 if test -z "$force"
215 then
216 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
217 die "$(eval_gettext "'\$sm_path' already exists in the index")"
218 else
219 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
220 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
221 fi
ecda0723 222
53213994
JK
223 if test -z "$force" &&
224 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 225 then
6ff875c5 226 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 227\$sm_path
6ff875c5 228Use -f if you really want to add it." >&2
d27b876b
JL
229 exit 1
230 fi
231
73b0898d
JL
232 if test -n "$custom_name"
233 then
234 sm_name="$custom_name"
235 else
236 sm_name="$sm_path"
237 fi
238
0383bbb9
JK
239 if ! git submodule--helper check-name "$sm_name"
240 then
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
242 fi
243
d4264ca3 244 # perhaps the path exists and is already a git repo, else clone it
64394e3a 245 if test -e "$sm_path"
d4264ca3 246 then
496eeeb1 247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 248 then
64394e3a 249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 250 else
64394e3a 251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 252 fi
c2f93917 253
d4264ca3 254 else
4b7c286e
JL
255 if test -d ".git/modules/$sm_name"
256 then
257 if test -z "$force"
258 then
0d71dbfd 259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
261 die "$(eval_gettextln "\
262If you want to reuse this local git directory instead of cloning again from
263 \$realrepo
264use the '--force' option. If the local git directory is not the correct repo
265or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 266 else
0d71dbfd 267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
268 fi
269 fi
a0ef2934 270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 271 (
14111fc4 272 sanitize_submodule_env
d851ffb9
JH
273 cd "$sm_path" &&
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
275 case "$branch" in
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
278 esac
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 280 fi
73b0898d 281 git config submodule."$sm_name".url "$realrepo"
d4264ca3 282
53213994 283 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 285
73b0898d
JL
286 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
287 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
288 if test -n "$branch"
289 then
290 git config -f .gitmodules submodule."$sm_name".branch "$branch"
291 fi &&
31991b02 292 git add --force .gitmodules ||
64394e3a 293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
294
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
298 then
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
302 then
303 git config submodule."$sm_name".active "true"
304 fi
305 else
306 git config submodule."$sm_name".active "true"
307 fi
ecda0723
SV
308}
309
19a31f9c
ML
310#
311# Execute an arbitrary command sequence in each checked out
312# submodule
313#
314# $@ = command to execute
315#
316cmd_foreach()
317{
1d5bec8b
JH
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
320 do
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
324 ;;
15fc56a8
JH
325 --recursive)
326 recursive=1
327 ;;
1d5bec8b
JH
328 -*)
329 usage
330 ;;
331 *)
332 break
333 ;;
334 esac
335 shift
336 done
337
fc1b9243 338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
19a31f9c
ML
339}
340
70c7ac22 341#
211b7f19 342# Register submodules in .git/config
70c7ac22
LH
343#
344# $@ = requested paths (default to all)
345#
23a485e3 346cmd_init()
70c7ac22 347{
5c08dbbd
JH
348 # parse $args after "submodule ... init".
349 while test $# -ne 0
350 do
351 case "$1" in
352 -q|--quiet)
2e6a30ef 353 GIT_QUIET=1
5c08dbbd
JH
354 ;;
355 --)
356 shift
357 break
358 ;;
359 -*)
360 usage
361 ;;
362 *)
363 break
364 ;;
365 esac
366 shift
367 done
368
6e7c14e6 369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
370}
371
cf419828
JL
372#
373# Unregister submodules from .git/config and remove their work tree
374#
cf419828
JL
375cmd_deinit()
376{
377 # parse $args after "submodule ... deinit".
f6a52799 378 deinit_all=
cf419828
JL
379 while test $# -ne 0
380 do
381 case "$1" in
382 -f|--force)
383 force=$1
384 ;;
385 -q|--quiet)
386 GIT_QUIET=1
387 ;;
f6a52799
SB
388 --all)
389 deinit_all=t
390 ;;
cf419828
JL
391 --)
392 shift
393 break
394 ;;
395 -*)
396 usage
397 ;;
398 *)
399 break
400 ;;
401 esac
402 shift
403 done
404
2e612731 405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
406}
407
fb43e31f 408is_tip_reachable () (
01e1d544 409 sanitize_submodule_env &&
fb43e31f
SB
410 cd "$1" &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
412 test -z "$rev"
413)
414
415fetch_in_submodule () (
01e1d544 416 sanitize_submodule_env &&
fb43e31f
SB
417 cd "$1" &&
418 case "$2" in
419 '')
420 git fetch ;;
421 *)
6cbf454a
SB
422 shift
423 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
424 esac
425)
426
70c7ac22 427#
211b7f19 428# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
429#
430# $@ = requested paths (default to all)
431#
23a485e3 432cmd_update()
70c7ac22 433{
5c08dbbd
JH
434 # parse $args after "submodule ... update".
435 while test $# -ne 0
436 do
437 case "$1" in
438 -q|--quiet)
2e6a30ef 439 GIT_QUIET=1
5c08dbbd 440 ;;
72c5f883 441 --progress)
c7199e3a 442 progress=1
72c5f883 443 ;;
be4d2c83 444 -i|--init)
d92a3959 445 init=1
be4d2c83 446 ;;
06b1abb5
TK
447 --remote)
448 remote=1
449 ;;
31ca3ac3 450 -N|--no-fetch)
31ca3ac3
FF
451 nofetch=1
452 ;;
9db31bdf
NMC
453 -f|--force)
454 force=$1
455 ;;
ca2cedba 456 -r|--rebase)
32948425 457 update="rebase"
ca2cedba 458 ;;
d92a3959
MT
459 --reference)
460 case "$2" in '') usage ;; esac
461 reference="--reference=$2"
98dbe63d 462 shift
d92a3959
MT
463 ;;
464 --reference=*)
465 reference="$1"
d92a3959 466 ;;
a0ef2934
CF
467 --dissociate)
468 dissociate=1
469 ;;
42b49178 470 -m|--merge)
42b49178
JH
471 update="merge"
472 ;;
b13fd5c1 473 --recursive)
b13fd5c1
JH
474 recursive=1
475 ;;
efc5fb6a
JH
476 --checkout)
477 update="checkout"
478 ;;
abed000a
SB
479 --recommend-shallow)
480 recommend_shallow="--recommend-shallow"
481 ;;
482 --no-recommend-shallow)
483 recommend_shallow="--no-recommend-shallow"
484 ;;
275cd184
FG
485 --depth)
486 case "$2" in '') usage ;; esac
487 depth="--depth=$2"
488 shift
489 ;;
490 --depth=*)
491 depth=$1
492 ;;
2335b870
SB
493 -j|--jobs)
494 case "$2" in '') usage ;; esac
495 jobs="--jobs=$2"
496 shift
497 ;;
498 --jobs=*)
499 jobs=$1
500 ;;
5c08dbbd
JH
501 --)
502 shift
503 break
504 ;;
505 -*)
506 usage
507 ;;
508 *)
509 break
510 ;;
511 esac
98dbe63d 512 shift
5c08dbbd
JH
513 done
514
d92a3959
MT
515 if test -n "$init"
516 then
517 cmd_init "--" "$@" || return
518 fi
519
48308681
SB
520 {
521 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 522 ${progress:+"--progress"} \
48308681
SB
523 ${wt_prefix:+--prefix "$wt_prefix"} \
524 ${prefix:+--recursive-prefix "$prefix"} \
525 ${update:+--update "$update"} \
5f50f33e 526 ${reference:+"$reference"} \
a0ef2934 527 ${dissociate:+"--dissociate"} \
48308681 528 ${depth:+--depth "$depth"} \
c7199e3a
CF
529 $recommend_shallow \
530 $jobs \
c4c02bf1 531 "$@" || echo "#unmatched" $?
48308681 532 } | {
15ffb7cd 533 err=
cf9e55f4 534 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 535 do
c4c02bf1 536 die_if_unmatched "$mode" "$sha1"
48308681 537
0ea306ef 538 name=$(git submodule--helper name "$sm_path") || exit
efc5fb6a
JH
539 if ! test -z "$update"
540 then
541 update_module=$update
542 else
543 update_module=$(git config submodule."$name".update)
a2aed08b
TK
544 if test -z "$update_module"
545 then
546 update_module="checkout"
547 fi
efc5fb6a
JH
548 fi
549
44431df0 550 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 551
48308681 552 if test $just_cloned -eq 1
d851ffb9 553 then
bf2d8246 554 subsha1=
e7b37caf
SB
555 case "$update_module" in
556 merge | rebase | none)
557 update_module=checkout ;;
558 esac
bf2d8246 559 else
14111fc4 560 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 561 git rev-parse --verify HEAD) ||
091a6eb0 562 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 563 fi
211b7f19 564
06b1abb5
TK
565 if test -n "$remote"
566 then
92bbe7cc 567 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
568 if test -z "$nofetch"
569 then
570 # Fetch remote before determining tracking $sha1
6cbf454a 571 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
572 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
573 fi
14111fc4
JK
574 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
575 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 576 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 577 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
578 fi
579
e9831750
SB
580 if ! $(git config -f "$(git rev-parse --git-common-dir)/modules/$name/config" core.worktree) 2>/dev/null
581 then
582 git submodule--helper connect-gitdir-workingtree "$name" "$sm_path"
583 fi
584
496eeeb1 585 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 586 then
9db31bdf
NMC
587 subforce=$force
588 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 589 if test -z "$subsha1" && test -z "$force"
b9b378a0 590 then
9db31bdf 591 subforce="-f"
b9b378a0 592 fi
31ca3ac3
FF
593
594 if test -z "$nofetch"
595 then
e5f522d6
JL
596 # Run fetch only if $sha1 isn't present or it
597 # is not reachable from a ref.
fb43e31f 598 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 599 fetch_in_submodule "$sm_path" $depth ||
e30d8336 600 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
601
602 # Now we tried the usual fetch, but $sha1 may
603 # not be reachable from any of the refs
604 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 605 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 606 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
607 fi
608
877449c1 609 must_die_on_failure=
32948425 610 case "$update_module" in
a2aed08b
TK
611 checkout)
612 command="git checkout $subforce -q"
613 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
614 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
615 ;;
32948425
JH
616 rebase)
617 command="git rebase"
091a6eb0
JK
618 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
619 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 620 must_die_on_failure=yes
32948425 621 ;;
42b49178
JH
622 merge)
623 command="git merge"
091a6eb0
JK
624 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
625 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 626 must_die_on_failure=yes
42b49178 627 ;;
6cb5728c
CP
628 !*)
629 command="${update_module#!}"
b08238ac
SB
630 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
631 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
632 must_die_on_failure=yes
633 ;;
32948425 634 *)
ff03d930 635 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 636 esac
70c7ac22 637
14111fc4 638 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 639 then
ff968f03 640 say "$say_msg"
877449c1
JH
641 elif test -n "$must_die_on_failure"
642 then
ff968f03 643 die_with_status 2 "$die_msg"
15ffb7cd 644 else
ff968f03 645 err="${err};$die_msg"
877449c1 646 continue
15ffb7cd 647 fi
70c7ac22 648 fi
b13fd5c1
JH
649
650 if test -n "$recursive"
651 then
75bf5e60 652 (
44431df0 653 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 654 wt_prefix=
14111fc4 655 sanitize_submodule_env
75bf5e60 656 cd "$sm_path" &&
36141282 657 eval cmd_update
75bf5e60 658 )
15ffb7cd
FG
659 res=$?
660 if test $res -gt 0
661 then
091a6eb0 662 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 663 if test $res -ne 2
15ffb7cd 664 then
ff968f03 665 err="${err};$die_msg"
15ffb7cd
FG
666 continue
667 else
ff968f03 668 die_with_status $res "$die_msg"
15ffb7cd
FG
669 fi
670 fi
b13fd5c1 671 fi
70c7ac22 672 done
15ffb7cd
FG
673
674 if test -n "$err"
675 then
676 OIFS=$IFS
677 IFS=';'
678 for e in $err
679 do
680 if test -n "$e"
681 then
682 echo >&2 "$e"
683 fi
684 done
685 IFS=$OIFS
686 exit 1
687 fi
688 }
70c7ac22
LH
689}
690
28f9af5d
PY
691#
692# Show commit summary for submodules in index or working tree
693#
694# If '--cached' is given, show summary between index and given commit,
695# or between working tree and given commit
696#
697# $@ = [commit (default 'HEAD'),] requested paths (default all)
698#
699cmd_summary() {
f2dc06a3 700 summary_limit=-1
d0f64dd4 701 for_status=
1c244f6e 702 diff_cmd=diff-index
f2dc06a3 703
28f9af5d
PY
704 # parse $args after "submodule ... summary".
705 while test $# -ne 0
706 do
707 case "$1" in
708 --cached)
709 cached="$1"
710 ;;
1c244f6e
JL
711 --files)
712 files="$1"
713 ;;
d0f64dd4
PY
714 --for-status)
715 for_status="$1"
716 ;;
f2dc06a3 717 -n|--summary-limit)
862ae6cd
RS
718 summary_limit="$2"
719 isnumber "$summary_limit" || usage
f2dc06a3
PY
720 shift
721 ;;
862ae6cd
RS
722 --summary-limit=*)
723 summary_limit="${1#--summary-limit=}"
724 isnumber "$summary_limit" || usage
725 ;;
28f9af5d
PY
726 --)
727 shift
728 break
729 ;;
730 -*)
731 usage
732 ;;
733 *)
734 break
735 ;;
736 esac
737 shift
738 done
bffe71f4 739
f2dc06a3
PY
740 test $summary_limit = 0 && return
741
3deea89c 742 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
743 then
744 head=$rev
caa9c3ca 745 test $# = 0 || shift
496eeeb1 746 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 747 then
14e940d7
JH
748 # before the first commit: compare with an empty tree
749 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 750 test -z "$1" || shift
28f9af5d 751 else
3deea89c 752 head="HEAD"
28f9af5d
PY
753 fi
754
1c244f6e
JL
755 if [ -n "$files" ]
756 then
757 test -n "$cached" &&
465d6a00 758 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
759 diff_cmd=diff-files
760 head=
761 fi
762
28f9af5d 763 cd_to_toplevel
091a6eb0 764 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 765 # Get modified modules cared by user
18076502 766 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 767 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 768 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
769 do
770 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
771 if test "$status" = D || test "$status" = T
772 then
6a066230 773 printf '%s\n' "$sm_path"
496eeeb1
EP
774 continue
775 fi
927b26f8 776 # Respect the ignore setting for --for-status.
777 if test -n "$for_status"
778 then
0ea306ef 779 name=$(git submodule--helper name "$sm_path")
927b26f8 780 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 781 test $status != A && test $ignore_config = all && continue
927b26f8 782 fi
28f9af5d 783 # Also show added or modified modules which are checked out
974ce807 784 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 785 printf '%s\n' "$sm_path"
28f9af5d
PY
786 done
787 )
1cb639e6 788
d0f64dd4
PY
789 test -z "$modules" && return
790
18076502 791 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 792 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 793 cut -c2- |
cf9e55f4 794 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
795 do
796 if test -z "$cached" &&
797 test $sha1_dst = 0000000000000000000000000000000000000000
798 then
799 case "$mod_dst" in
800 160000)
801 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
802 ;;
803 100644 | 100755 | 120000)
804 sha1_dst=$(git hash-object $name)
805 ;;
806 000000)
807 ;; # removed
808 *)
809 # unexpected type
6ff875c5 810 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
811 continue ;;
812 esac
813 fi
814 missing_src=
815 missing_dst=
816
817 test $mod_src = 160000 &&
974ce807 818 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
819 missing_src=t
820
821 test $mod_dst = 160000 &&
974ce807 822 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 823 missing_dst=t
bffe71f4 824
44431df0 825 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 826
1cb639e6
PY
827 total_commits=
828 case "$missing_src,$missing_dst" in
829 t,)
091a6eb0 830 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
831 ;;
832 ,t)
091a6eb0 833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
834 ;;
835 t,t)
091a6eb0 836 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
837 ;;
838 *)
839 errmsg=
840 total_commits=$(
496eeeb1 841 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
842 then
843 range="$sha1_src...$sha1_dst"
844 elif test $mod_src = 160000
845 then
846 range=$sha1_src
847 else
848 range=$sha1_dst
849 fi
850 GIT_DIR="$name/.git" \
b0e621ad 851 git rev-list --first-parent $range -- | wc -l
1cb639e6 852 )
eed35595 853 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
854 ;;
855 esac
856
857 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
858 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
859 if test $status = T
860 then
b3e73449
ÆAB
861 blob="$(gettext "blob")"
862 submodule="$(gettext "submodule")"
1cb639e6
PY
863 if test $mod_dst = 160000
864 then
091a6eb0 865 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 866 else
091a6eb0 867 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
868 fi
869 else
091a6eb0 870 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
871 fi
872 if test -n "$errmsg"
873 then
874 # Don't give error msg for modification whose dst is not submodule
875 # i.e. deleted or changed to blob
876 test $mod_dst = 160000 && echo "$errmsg"
877 else
496eeeb1 878 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 879 then
f2dc06a3
PY
880 limit=
881 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 882 GIT_DIR="$name/.git" \
f2dc06a3 883 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
884 --first-parent $sha1_src...$sha1_dst
885 elif test $mod_dst = 160000
886 then
887 GIT_DIR="$name/.git" \
888 git log --pretty='format: > %s' -1 $sha1_dst
889 else
890 GIT_DIR="$name/.git" \
891 git log --pretty='format: < %s' -1 $sha1_src
892 fi
893 echo
894 fi
895 echo
3ba7407b 896 done
28f9af5d 897}
70c7ac22 898#
941987a5 899# List all submodules, prefixed with:
70c7ac22
LH
900# - submodule not initialized
901# + different revision checked out
902#
903# If --cached was specified the revision in the index will be printed
904# instead of the currently checked out revision.
905#
906# $@ = requested paths (default to all)
907#
23a485e3 908cmd_status()
70c7ac22 909{
5c08dbbd
JH
910 # parse $args after "submodule ... status".
911 while test $# -ne 0
912 do
913 case "$1" in
914 -q|--quiet)
2e6a30ef 915 GIT_QUIET=1
5c08dbbd
JH
916 ;;
917 --cached)
918 cached=1
919 ;;
64b19ffe
JH
920 --recursive)
921 recursive=1
922 ;;
5c08dbbd
JH
923 --)
924 shift
925 break
926 ;;
927 -*)
928 usage
929 ;;
930 *)
931 break
932 ;;
933 esac
934 shift
935 done
936
a9f8a375 937 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 938}
2327f61e
DA
939#
940# Sync remote urls for submodules
941# This makes the value for remote.$remote.url match the value
942# specified in .gitmodules.
943#
944cmd_sync()
945{
946 while test $# -ne 0
947 do
948 case "$1" in
949 -q|--quiet)
2e6a30ef 950 GIT_QUIET=1
2327f61e
DA
951 shift
952 ;;
82f49f29
PH
953 --recursive)
954 recursive=1
955 shift
956 ;;
2327f61e
DA
957 --)
958 shift
959 break
960 ;;
961 -*)
962 usage
963 ;;
964 *)
965 break
966 ;;
967 esac
968 done
e7849a96 969
13424764 970 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 971}
70c7ac22 972
f6f85861
SB
973cmd_absorbgitdirs()
974{
975 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
976}
977
5c08dbbd
JH
978# This loop parses the command line arguments to find the
979# subcommand name to dispatch. Parsing of the subcommand specific
980# options are primarily done by the subcommand implementations.
981# Subcommand specific options such as --branch and --cached are
982# parsed here as well, for backward compatibility.
983
984while test $# != 0 && test -z "$command"
70c7ac22
LH
985do
986 case "$1" in
f6f85861 987 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 988 command=$1
70c7ac22
LH
989 ;;
990 -q|--quiet)
2e6a30ef 991 GIT_QUIET=1
70c7ac22 992 ;;
ecda0723
SV
993 -b|--branch)
994 case "$2" in
995 '')
996 usage
997 ;;
998 esac
999 branch="$2"; shift
1000 ;;
70c7ac22 1001 --cached)
28f9af5d 1002 cached="$1"
70c7ac22
LH
1003 ;;
1004 --)
1005 break
1006 ;;
1007 -*)
1008 usage
1009 ;;
1010 *)
1011 break
1012 ;;
1013 esac
1014 shift
1015done
1016
5c08dbbd 1017# No command word defaults to "status"
af9c9f97
RR
1018if test -z "$command"
1019then
1020 if test $# = 0
1021 then
1022 command=status
1023 else
1024 usage
1025 fi
1026fi
5c08dbbd
JH
1027
1028# "-b branch" is accepted only by "add"
1029if test -n "$branch" && test "$command" != add
1030then
ecda0723 1031 usage
5c08dbbd
JH
1032fi
1033
28f9af5d 1034# "--cached" is accepted only by "status" and "summary"
496eeeb1 1035if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1036then
70c7ac22 1037 usage
5c08dbbd
JH
1038fi
1039
1040"cmd_$command" "$@"